/****************************************************************************
              Copyright (c) 2012 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : Analog_Handler.h
   Author             : Jonathan Serrano
   Version            : V0.0.0.1
   Origination Date   : 07/05/2019
   Description        : C Source File.
   Environment        : Independent
   Processor:         : STM32F746IG

-----------------------------------------------------------------------------
   Description:

   This follow the next specification file:

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.0              02/18/2020         Jonathan Serrano

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/

#ifndef _ANALOG_HANDLER_H_
#define	_ANALOG_HANDLER_H_

#include "main.h"

/* Private functions declaration -------------------------------------------*/
uint32_t ADCtoResistance(uint32_t channel_A,uint32_t channel_B, uint8_t analog_input_index);
uint32_t ADCtoVLow (uint32_t channel_A,uint32_t channel_B);
uint32_t ADCtoVHigh (uint32_t channel_A,uint32_t channel_B);
uint32_t ADCtoCurrent (uint32_t channel_A,uint32_t channel_B);
uint32_t STB_convertion(uint32_t channel_A,uint32_t channel_B);
uint32_t STG_convertion(uint32_t channel_A,uint32_t channel_B);
uint32_t ADCtoFrequency (uint8_t index);
uint32_t GetADC_Results(int i);
uint32_t FI_Get_CINx_Frequency(int idx);
uint32_t ADCtoBattMonitor(uint32_t channel_A, uint32_t channel_B);


#endif	//_ANALOG_HANDLER_H_

/**************** (C) COPYRIGHT 2012 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
