/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : DL_U16_validation.h
   Author             : Rajesh
   Version            : V0.0.0.1
   Origination Date   : 21/01/2022
   Description        : Header File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the DataBase DataLayer 16-bit field Validation functions

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             21/01/2022           Rajesh

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/

#ifndef _DL_U16_VALIDATION_H_
#define	_DL_U16_VALIDATION_H_

/* USER CODE BEGIN EFP */
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)
int8_t validate_wl_blinking(uint16_t wl_num ,uint16_t blink_period);
#endif

#if (SDK_SERVICE_LED == PS_ENABLE)
int8_t validate_led_blinking(uint16_t led_idx, uint16_t blink_period);
#endif

#if (SDK_SERVICE_CFG_INPUT == PS_ENABLE)
int8_t validate_cfg_voltage(uint16_t cfg_idx, uint16_t voltage);
int8_t validate_cfg_resistance(uint16_t cfg_idx, uint16_t resistance);
#endif

#if (SDK_SERVICE_POWER_MONITOR == PS_ENABLE)
int8_t validate_battery_level(uint16_t battery_idx, uint16_t battery_level);
#endif

#if (SDK_SERVICE_SWTIMER == PS_ENABLE)
int8_t validate_timer_timeout(uint16_t db_idx, uint16_t timeout_val);
#endif

#if (SDK_SERVICE_CAMERA == PS_ENABLE)
int8_t validate_x0_width_val(uint16_t db_idx, uint16_t height);
int8_t validate_y0_height_val(uint16_t db_idx, uint16_t width);
int8_t validate_x0_origin_val(uint16_t db_idx, uint16_t origin_x0);
int8_t validate_y0_origin_val(uint16_t db_idx, uint16_t origin_y0);
#endif

#if (SDK_SERVICE_LCD == PS_ENABLE)
int8_t validate_display_x0_origin_val(uint16_t db_idx, uint16_t disp_origin_x0);
int8_t validate_display_y0_origin_val(uint16_t db_idx, uint16_t disp_origin_y0);
#endif

int8_t validate_u16_dummy_field(uint16_t dummy1, uint16_t dummy2);

/* USER CODE END EFP */

#endif	//_DB_PLATFORM_SERVICE_H_

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
