/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : SDK_API.h
   Author             : Rajesh
   Version            : V0.0.0.1
   Origination Date   : 21/01/2022
   Description        : Header File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the SDK API declaration

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             21/01/2022           Rajesh

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/


#ifndef _SDK_API_H_
#define	_SDK_API_H_

/* USER CODE BEGIN EFP */
/*!
 * Warning Light SDK APIs
 */
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)
uint8_t ActWLT(uint8_t wl_number, uint16_t blinking_period, uint8_t duty_cycle);
uint8_t SetWLT(uint8_t wl_number, uint8_t *cbuf);
#endif

#if (SDK_SERVICE_KEYPAD == PS_ENABLE)
uint8_t SetKPD(uint8_t keypad_id, uint8_t state);
#endif

#if (SDK_SERVICE_RTC == PS_ENABLE)
uint8_t SetRTC(RTC_Func func, rtc_ps *param, uint8_t format);
#endif

#if (SDK_SERVICE_DIGITAL_OUTPUT == PS_ENABLE)
uint8_t SetDIO(DIO_Func func, uint8_t state);
uint8_t GetDIO(uint8_t *state);
#endif

#if (SDK_SERVICE_LIGHT_SENSOR == PS_ENABLE)
uint8_t SetLTS(uint8_t func, uint8_t value);
uint8_t GetLTS(uint8_t func, uint8_t *value);
#endif

#if (SDK_SERVICE_WATCHDOG == PS_ENABLE)
uint8_t SetWD(uint8_t ping_id);
#endif

#if (SDK_SERVICE_LED == PS_ENABLE)
uint8_t ActLED(uint8_t led_number, uint16_t blinking_period);
uint8_t SetLED(uint8_t led_number, uint8_t *lbuf);
#endif

#if (SDK_SERVICE_CFG_INPUT == PS_ENABLE)
uint8_t SetCGI(uint8_t set_state, uint8_t ci_type, uint8_t value);
uint8_t GetCGI(uint8_t set_state, uint8_t ci_type_idx, uint8_t *value);
#endif

#if (SDK_SERVICE_LCD == PS_ENABLE)
uint8_t SetLCD(LCD_Func lcd_fun, uint8_t value);
uint8_t GetLCD(LCD_Func lcd_fun, uint8_t *value);
#endif

#if (SDK_SERVICE_PM == PS_ENABLE)
uint8_t SetPWR(uint8_t mode);
#endif

#if (SDK_SERVICE_EEPROM == PS_ENABLE)
uint8_t SetERM(uint16_t eeph, uint8_t *data);
uint8_t GetERM(uint16_t eeph, uint8_t *data);
#endif

#if (SDK_SERVICE_SWTIMER == PS_ENABLE)
uint8_t SetSWT(uint8_t timer_idx, uint8_t status, uint8_t mode, uint16_t timeoutms);
uint8_t GetSWT(uint8_t *status, uint8_t *mode, uint16_t *timeoutms);
#endif

#if (SDK_SERVICE_BLE == PS_ENABLE)
uint8_t SetBLE(int8_t *data, uint8_t len);
uint8_t GetBLE(uint32_t *data, uint8_t len);
#endif

#if (SDK_SERVICE_USB == PS_ENABLE)
int8_t SetUSB(int8_t *data, uint8_t len);
uint8_t GetUSB(uint8_t *data, uint8_t len);
#endif

#if (SDK_SERVICE_CAMERA == PS_ENABLE)
uint8_t SetCam(uint8_t mode, uint8_t *buf);
#endif

#if (SDK_SERVICE_FDCAN == PS_ENABLE)
int8_t ActCAN(uint8_t canid, uint8_t can_cfg, uint8_t *cfg_val);
int8_t SetCAN(uint8_t canid, uint8_t *data, uint8_t len);
#endif

#if (SDK_SERVICE_J1939 == PS_ENABLE)
uint8_t Setj1939(uint8_t j1939_fun, uint8_t *data);
#endif

/* USER CODE END EFP */

#endif //_SDK_API_H_

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
