/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : DL_jU16_Validation.c
   Author             : Rajesh
   Version            : V0.0.0.1
   Origination Date   : 24/05/2022
   Description        : C Source File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the Data Layer j1939 unsigned 8 bits field validation function

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             24/05/2022           Rajesh

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/

/* USER CODE BEGIN Includes */
#include "../../Maximatecc/Inc/Data_Layer.h"
#include "../Inc/Common.h"
#include "../Inc/DL_jU16_Validation.h"
/* USER CODE END Includes */

/* USER CODE BEGIN Global Variables */
/* USER CODE END Includes */

int8_t (*dl_ju16_func [(END_J1939U16BIT - 1) - START_J1939U16BIT])(uint16_t, uint16_t);

extern pvt_variable pv;
/* USER CODE END Global Variables */

/** @brief DB Validation function
 *
 *  This function initialize the DB Validation function for the each
 *  j1939 unsinged 8 bits field.
 *
 *  @param  None
 *
 *  @return None
 *
 */
void DB_ju16_Field_Validation_Reg(void)
{
	/* Clear the Callback memory */
	memset (&dl_ju16_func[0], 0x00, ((END_J1939U16BIT - 1) - START_J1939U16BIT));

#if (SDK_SERVICE_J1939 == PS_ENABLE)
    /* CAN0_DEST_ADD Validation */
	dl_ju16_func[CAN0_DEST_ADD - (START_J1939U16BIT + 1)] = validate_j1939_u16_variable;

    /* CAN1_DEST_ADD Validation */
	dl_ju16_func[CAN1_DEST_ADD - (START_J1939U16BIT + 1)] = validate_j1939_u16_variable;

    /* MANUFACTURER_CODE_60920 Validation */
	dl_ju16_func[MANUFACTURER_CODE_60920 - (START_J1939U16BIT + 1)] = validate_j1939_u16_variable;

    /* ENGINE_OIL_TEMP_1 Validation */
	dl_ju16_func[ENGINE_OIL_TEMP_1 - (START_J1939U16BIT + 1)] = validate_j1939_u16_variable;

    /* ENGINE_TURBOCHARGER_OIL_TEMP Validation */
	dl_ju16_func[ENGINE_TURBOCHARGER_OIL_TEMP - (START_J1939U16BIT + 1)] = validate_j1939_u16_variable;

    /* MANUFACTURER_CODE_60928 Validation */
	dl_ju16_func[MANUFACTURER_CODE_60928 - (START_J1939U16BIT + 1)] = validate_j1939_u16_variable;

#endif	//SDK_SERVICE_J1939

}


#if (SDK_SERVICE_J1939 == PS_ENABLE)
/** @brief validation j1939 variable
 *
 *  This function validates the j1939 variable.
 *
 *  @param  db_idx [IN]  : DB Field
 *          val    [IN]  : variable val
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_j1939_u16_variable(uint16_t db_idx, uint16_t val)
{
	return SUCCESS;
}

#endif	//SDK_SERVICE_J1939
