/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : Warning_Light_platformservice.c
   Author             : Rajesh
   Version            : V0.0.0.1
   Origination Date   : 21/01/2022
   Description        : C Source File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the Warning light platform service initialization

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.0             21/01/2022           Rajesh

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/

/* USER CODE BEGIN Includes */
#include "../../Maximatecc/Inc/common.h"
/* USER CODE END Includes */

/* USER CODE BEGIN Global Variables */
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)
extern pvt_variable pv;
WL_Blinking_info wlconf[MAX_NUM_WARNING_LIGHT] =
{
	    /*Enable, WL State, PWM duty cycle, Duration to blinking, Current timer count */
		{((CONF_WARNING_LIGHT_01_CURRENT << 2) | CONF_WARNING_LIGHT_01_ENABLE), CONF_WARNING_LIGHT_01_POWERON_STATE,
		        CONF_WARNING_LIGHT_01_PWM_DC, CONF_WARNING_LIGHT_01_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_02_CURRENT << 2) | CONF_WARNING_LIGHT_02_ENABLE), CONF_WARNING_LIGHT_02_POWERON_STATE,
		        CONF_WARNING_LIGHT_02_PWM_DC, CONF_WARNING_LIGHT_02_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_03_CURRENT << 2) | CONF_WARNING_LIGHT_03_ENABLE), CONF_WARNING_LIGHT_03_POWERON_STATE,
		        CONF_WARNING_LIGHT_03_PWM_DC, CONF_WARNING_LIGHT_03_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_04_CURRENT << 2) | CONF_WARNING_LIGHT_04_ENABLE), CONF_WARNING_LIGHT_04_POWERON_STATE,
	            CONF_WARNING_LIGHT_04_PWM_DC, CONF_WARNING_LIGHT_04_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_05_CURRENT << 2) | CONF_WARNING_LIGHT_05_ENABLE), CONF_WARNING_LIGHT_05_POWERON_STATE,
		        CONF_WARNING_LIGHT_05_PWM_DC, CONF_WARNING_LIGHT_05_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_06_CURRENT << 2) | CONF_WARNING_LIGHT_06_ENABLE), CONF_WARNING_LIGHT_06_POWERON_STATE,
		        CONF_WARNING_LIGHT_06_PWM_DC, CONF_WARNING_LIGHT_06_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_07_CURRENT << 2) | CONF_WARNING_LIGHT_07_ENABLE), CONF_WARNING_LIGHT_07_POWERON_STATE,
		        CONF_WARNING_LIGHT_07_PWM_DC, CONF_WARNING_LIGHT_07_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_08_CURRENT << 2) | CONF_WARNING_LIGHT_08_ENABLE), CONF_WARNING_LIGHT_08_POWERON_STATE,
		        CONF_WARNING_LIGHT_08_PWM_DC, CONF_WARNING_LIGHT_08_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_09_CURRENT << 2) | CONF_WARNING_LIGHT_09_ENABLE), CONF_WARNING_LIGHT_09_POWERON_STATE,
		        CONF_WARNING_LIGHT_09_PWM_DC, CONF_WARNING_LIGHT_09_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_10_CURRENT << 2) | CONF_WARNING_LIGHT_10_ENABLE), CONF_WARNING_LIGHT_10_POWERON_STATE,
		        CONF_WARNING_LIGHT_10_PWM_DC, CONF_WARNING_LIGHT_10_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_11_CURRENT << 2) | CONF_WARNING_LIGHT_11_ENABLE), CONF_WARNING_LIGHT_11_POWERON_STATE,
		        CONF_WARNING_LIGHT_11_PWM_DC, CONF_WARNING_LIGHT_11_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_12_CURRENT << 2) | CONF_WARNING_LIGHT_12_ENABLE), CONF_WARNING_LIGHT_12_POWERON_STATE,
		        CONF_WARNING_LIGHT_12_PWM_DC, CONF_WARNING_LIGHT_12_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_13_CURRENT << 2) | CONF_WARNING_LIGHT_13_ENABLE), CONF_WARNING_LIGHT_13_POWERON_STATE,
		        CONF_WARNING_LIGHT_13_PWM_DC, CONF_WARNING_LIGHT_13_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_14_CURRENT << 2) | CONF_WARNING_LIGHT_14_ENABLE), CONF_WARNING_LIGHT_14_POWERON_STATE,
		        CONF_WARNING_LIGHT_14_PWM_DC, CONF_WARNING_LIGHT_14_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_15_CURRENT << 2) | CONF_WARNING_LIGHT_15_ENABLE), CONF_WARNING_LIGHT_15_POWERON_STATE,
		        CONF_WARNING_LIGHT_15_PWM_DC,CONF_WARNING_LIGHT_15_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_16_CURRENT << 2) | CONF_WARNING_LIGHT_16_ENABLE), CONF_WARNING_LIGHT_16_POWERON_STATE,
		        CONF_WARNING_LIGHT_16_PWM_DC, CONF_WARNING_LIGHT_16_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_17_CURRENT << 2) | CONF_WARNING_LIGHT_17_ENABLE), CONF_WARNING_LIGHT_17_POWERON_STATE,
		        CONF_WARNING_LIGHT_17_PWM_DC, CONF_WARNING_LIGHT_17_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_18_CURRENT << 2) | CONF_WARNING_LIGHT_18_ENABLE), CONF_WARNING_LIGHT_18_POWERON_STATE,
		        CONF_WARNING_LIGHT_18_PWM_DC, CONF_WARNING_LIGHT_18_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_19_CURRENT << 2) | CONF_WARNING_LIGHT_19_ENABLE), CONF_WARNING_LIGHT_19_POWERON_STATE,
		        CONF_WARNING_LIGHT_19_PWM_DC, CONF_WARNING_LIGHT_19_BLINKING_MS, 0, 0},
		{((CONF_WARNING_LIGHT_20_CURRENT << 2) | CONF_WARNING_LIGHT_20_ENABLE), CONF_WARNING_LIGHT_20_POWERON_STATE,
		        CONF_WARNING_LIGHT_20_PWM_DC, CONF_WARNING_LIGHT_20_BLINKING_MS, 0, 0},

};
/* USER CODE END Global Variables */

#if (SDK_SERVICE_PM == PS_ENABLE)
/** @brief Warning light deinit
 *
 *  This function will make the shutdown pin to low.
 *  (The chip enters hardware shutdown mode
 *   when the SDB pin is pulled low)
 *
 *  @param  None
 *
 *  @return  None
 *
 */
void wl_deinit(void)
{
	/*Configure WL Shutdown pin to RESET */
	HAL_GPIO_WritePin(GPIOG, GPIO_PIN_1, GPIO_PIN_RESET);
}

/** @brief Warning light reinit
 *
 *  This function will make the shutdown pin to high.
 *  (The chip enters normal mode when the
 *  SDB pin is pulled high)
 *
 *  @param  None
 *
 *  @return  None
 *
 */
void wl_reinit(void)
{
	uint8_t index;

	/*Configure WL Shutdown pin to SET */
	HAL_GPIO_WritePin(GPIOG, GPIO_PIN_1, GPIO_PIN_SET);

    for (index = 0; index < MAX_NUM_WARNING_LIGHT; index++)
    {
    	if(WL_OFF == wlconf[index].wl_state)
            continue;

        TakeI2CBusLock();
        Warning_Light_On(pv.hi2c, index,
        			wlconf[index].wl_enable >> WL_REG_CURRENT_FIELD);
		GiveI2CBusLock();
    }
}
#endif

/** @brief Warning light Blinking
 *
 *  Blink the warning light with timer callback
 *
 *  @param  None
 *
 *  @return 0 : PS_SUCCESS
 *         -1 : PS_FAILURE
 *
 */
static int8_t Warning_Light_Blinking(void)
{
    uint8_t index;
    uint8_t enble_blnk_tmr = 0;

    for (index = 0; index < MAX_NUM_WARNING_LIGHT; index++)
    {
    	if(WL_OFF == wlconf[index].wl_state)
            continue;

        /* WL Blinking is Zero */
        if (wlconf[index].blk_time == 0)
        	continue;

        wlconf[index].cur_count++;

        /* Check for blinking timer elapse counter */
        if (wlconf[index].cur_count >= wlconf[index].blk_time )
        {
        	/* Reset the counter */
        	wlconf[index].cur_count = 0;

        	if (WL_ON == wlconf[index].blnk_state)
        	{
                /* Update the Next WL state */
                wlconf[index].blnk_state = WL_OFF;
                TakeI2CBusLock();
				Warning_Light_Off(pv.hi2c, index);
				GiveI2CBusLock();
        	}
        	else
        	{
                /* Update the Next WL state */
                wlconf[index].blnk_state = WL_ON;

                TakeI2CBusLock();
                Warning_Light_On(pv.hi2c, index,
                			wlconf[index].wl_enable >> WL_REG_CURRENT_FIELD);
                GiveI2CBusLock();
        	}
        }

        /* Enable the blinking timer again */
        enble_blnk_tmr = 1;
    }

    /* Check whether the blinking timer has to be stopped */
    if (0 == enble_blnk_tmr)
    {
		 /* STOP WL Blinking timer */
		 xTimerStop( pv.xTimers[ PS_WL_TIMER ], 0 );
    }
	return PS_SUCCESS;
}

/** @brief Warning light DB Initialization
 *
 *  This function takes the default configuration from the config header
 *  file and store the data into the DB.
 *
 *  @param  None
 *
 *  @return 0 : PS_SUCCESS
 *         -1 : PS_FAILURE
 *
 */
int8_t Warning_Light_DB_Init(void)
{
    uint8_t   wl_db1 = START_U8BIT + 1;
    uint16_t  wl_db2 = START_U16BIT + 1;
    uint8_t   index;

    if (MAX_NUM_WARNING_LIGHT > MAX_PLATFORM_SUPPORTED_WL )
    	return PS_FAILURE;

    /* Initialize the Warning light device */
    if (PS_FAILURE == Warning_Light_Init(pv.hi2c, WARNING_LIGHT_FREQ))
    	return PS_FAILURE;

    /* Initialize the Warning Light DB Variables */
    for (index = 0; index < MAX_NUM_WARNING_LIGHT; index++)
    {
    	/* Check the Warning Light state */
        if (PS_ENABLE != (wlconf[index].wl_enable & 1))
		{
        	//wlconf[index].wl_enable = PS_ENABLE;
        	wlconf[index].wl_enable = (wlconf[index].wl_enable | PS_ENABLE);
		}

        /* Check the Warning Light ON/OFF state */
        if ((WL_ON != wlconf[index].wl_state) &&
        		(WL_OFF != wlconf[index].wl_state))
		{
        	wlconf[index].wl_state = WL_OFF;
		}

        /* Check for the WL off state */
        if (WL_OFF & wlconf[index].wl_state)
        {
        	/* Update default (WARNING_LIGHT_xx_PWM_DC) DB Field  */
            Set_DL(wl_db1+1, &wlconf[index].duty_cyle);

        	/* Update default (WARNING_LIGHT_xx_BLINKING) DB Field  */
            Set_DL(wl_db2, (uint8_t *)&wlconf[index].blk_time);

        	/* Update default (WARNING_LIGHT_xx_STATE) DB Field  */
            Set_DL(wl_db1, &wlconf[index].wl_state);
        }

        /* Check the Warning Light Blinking period */
        if ((0 > wlconf[index].blk_time) ||
        		(WL_MAX_BLK_TIME < wlconf[index].blk_time))
		{
        	wlconf[index].blk_time = 0;
		}

        /* Check the Warning Light Duty Cycle period */
        if ((0 > wlconf[index].duty_cyle) ||
        		(WL_MAX_PWM_DC < wlconf[index].duty_cyle))
		{
        	wlconf[index].duty_cyle = 0;
		}

    	/* Update default (WARNING_LIGHT_xx_PWM_DC) DB Field  */
        Set_DL((wl_db1+1), &wlconf[index].duty_cyle);

    	/* Update default (WARNING_LIGHT_xx_BLINKING) DB Field  */
        Set_DL(wl_db2, (uint8_t*)&wlconf[index].blk_time);

    	/* Update default (WARNING_LIGHT_xx_STATE) DB Field  */
        Set_DL(wl_db1, &wlconf[index].wl_state);

        /* Increment for WARNING_LIGHT_xx_STATE and WARNING_LIGHT_xx_PWM_DC */
        wl_db1 += 2;
        wl_db2 += 1;

    }

    return PS_SUCCESS;
}

#if (SDK_CAM_WARNING_LIGHT_STOP == PS_ENABLE)
/** @brief Warning light Platform service task
 *
 *  This function starts the Warning light Platform Service
 *  task.
 *
 *  @param  state : State the running thread
 *
 *  @return SUCCESS
 *          FAILURE
 *
 */
uint8_t Stop_Warning_Light_Service(uint8_t state)
{
	uint8_t *buff;
	uint8_t res;
	/* Get the buffer from the Memory */
   	buff = (uint8_t *) ai430_memory_alloc();


   	/* Check the state */
	if (STATE_STOP == state)
	{
		state = WL_CAM_STOP_EVENT;
	}
	else
		state = WL_CAM_START_EVENT;

    buff[0]  = WL_CAM_STOP_EVENT;

	/* Send the data into the Warning Light Q */
	if (xQueueSend( pv.wltxq, ( void * )&buff, ( TickType_t ) Q_TICKSTOWAIT ) != pdPASS)
	{
		/* Release the buffer */
		ai430_memory_free(buff);
		return FAILURE;
	}

	/* Notify the WL task to update the WL data */
	if (xTaskNotify( pv.wl_task, (1<<state), eSetBits ) != pdPASS)
	{
		return FAILURE;
	}

	/* Wait for receiving the return data */
    /* Send the data to the Warning light platform service layer */
	if (xQueueReceive(pv.wlrxq, &buff, ( TickType_t ) Q_TICKSTOWAIT ) != pdPASS )
	{
		/* Release the buffer */
		ai430_memory_free(buff);
		return FAILURE;
	}

	res = buff[WL_RESULT_INDEX];

	/* Release the buffer */
	ai430_memory_free(buff);

	return res;
}
#endif


/** @brief Warning light Platform service task
 *
 *  This function starts the Warning light Platform Service
 *  task.
 *
 *  @param  pvParameters - Private data pointer
 *
 *  @return none
 *
 */
void Warning_Light_ServiceStart(void *pvParameters)
{
	uint8_t  *wlbuf;
	uint32_t cNotifiedValue;
	int8_t   res = 0;
	int8_t   index;
	uint8_t  func;
	TickType_t  th_timeout = PS_WL_TASK_TIMEOUT;


	/* Register with the Camera Driver */
#if (SDK_CAM_WARNING_LIGHT_STOP == PS_ENABLE)
	StartStopSDKServiceReg(Stop_Warning_Light_Service);
#endif

	/* Initialize the Warning Lights based on the User Configuration */
    for (index = 0; index < MAX_NUM_WARNING_LIGHT; index++)
    {
		/* Check the blinking time value is present  */
		/* If so, don't ON the WL now                 */
		/* this will be enabled from the timer       */
		if((wlconf[index].blk_time == 0) &&
				(wlconf[index].wl_state & WL_ON))
		{
			TakeI2CBusLock();
			/* Set the WL PWM */
			Set_Warning_Light_Intensity(pv.hi2c, index,
					wlconf[index].duty_cyle);
			/* Set the WL ON */
			Warning_Light_On(pv.hi2c, index,
					wlconf[index].wl_enable >> WL_REG_CURRENT_FIELD);
			GiveI2CBusLock();
		}
			/* WL Blinking period is non zero and WL is ON */
		else if((wlconf[index].blk_time != 0) &&
					(wlconf[index].wl_state & WL_ON) == WL_ON)
		{
			TakeI2CBusLock();
			/* Set the WL PWM */
			Set_Warning_Light_Intensity(pv.hi2c,
					index,
					wlconf[index].duty_cyle);

			Warning_Light_On(pv.hi2c, index,
				wlconf[index].wl_enable >> WL_REG_CURRENT_FIELD);
			GiveI2CBusLock();

        	/* Reset the counter */
        	wlconf[index].cur_count = 0;

			/* Update the NEXT state */
			wlconf[index].blnk_state = WL_OFF;

			/* Start WL Blinking timer */
			xTimerStart( pv.xTimers[ PS_WL_TIMER ], 0 );
		}
    }
	while(1)
	{
#if (SDK_SERVICE_WATCHDOG == PS_ENABLE)
		/* Ping the watchdog timer */
		res = SetWD(WD_PING_WL_TASK);

		if(res != SUCCESS)
		{
			LOGERROR("WL Task failed to ping the WD Timer\r\n");
		}
#endif

		/* Wait for receiving the Event from the SDK API and WL timer */
		res = xTaskNotifyWait( 0x00, ULONG_MAX , &cNotifiedValue, th_timeout);

		if(res != pdTRUE)
		{
			continue;
		}

#if (SDK_CAM_WARNING_LIGHT_STOP == PS_ENABLE)
		/* Camera is streaming, stop the SDK thread */
		if ((cNotifiedValue & (1<< WL_CAM_STOP_EVENT)) &&
				(pv.wl_cam_state != WL_THREAD_STATE_STOP))
		{
			/* Start WL Blinking timer */
        	if (pdTRUE == xTimerIsTimerActive(pv.xTimers[PS_WL_TIMER]))
			{
				/* Stop LED Blinking timer */
				 xTimerStop( pv.xTimers[ PS_WL_TIMER ], 0 );
			}

			/* OFF ALL the WL */
		    for (index = 0; index < MAX_NUM_WARNING_LIGHT; index++)
		    {
		    	if(WL_OFF == wlconf[index].wl_state)
		            continue;

		        TakeI2CBusLock();
		        Warning_Light_Off(pv.hi2c, index);
				GiveI2CBusLock();
		    }
		    pv.wl_cam_state = WL_THREAD_STATE_STOP;

		    th_timeout = portMAX_DELAY;

		    /* Update the result */
			wlbuf[USB_RESULT_INDEX] = SUCCESS;

			/* Send the response to the SDK API */
			xQueueSend( pv.wlrxq, ( void * )&wlbuf, ( TickType_t ) Q_TICKSTOWAIT );
			continue;
		}

		/* Camera is stopped streaming, start the SDK thread */
		if ((cNotifiedValue & (1<< WL_CAM_START_EVENT)) &&
			(pv.wl_cam_state != WL_THREAD_STATE_RUN))
		{
			/* ON the WL */
		    for (index = 0; index < MAX_NUM_WARNING_LIGHT; index++)
		    {
		    	if(WL_OFF == wlconf[index].wl_state)
		            continue;

		    	if (0 > wlconf[index].blk_time)
		    		res = 1;

		        TakeI2CBusLock();
		        Warning_Light_On(pv.hi2c, index,
		                			wlconf[index].wl_enable >> WL_REG_CURRENT_FIELD);
				GiveI2CBusLock();
		    }

		    /* Start WL Blinking timer */
        	if (1 == res)
			{
        		res = 0;

				/* Start LED Blinking timer */
				xTimerStart( pv.xTimers[ PS_WL_TIMER ], 0 );
			}

		    pv.wl_cam_state = WL_THREAD_STATE_RUN;
			th_timeout = PS_WL_TASK_TIMEOUT;

			/* Update the result */
			wlbuf[USB_RESULT_INDEX] = SUCCESS;

			/* Send the response to the SDK API */
			xQueueSend( pv.wlrxq, ( void * )&wlbuf, ( TickType_t ) Q_TICKSTOWAIT );

		    continue;
		}

		/* Receive any event, do not accept. Since the camera is running */
		if (WL_THREAD_STATE_STOP == pv.wl_cam_state)
		{
			/* Update the result */
			wlbuf[WL_RESULT_INDEX] = FAILURE;

			/* Send the response to the SDK API */
			xQueueSend( pv.wlrxq, ( void * )&wlbuf, ( TickType_t ) Q_TICKSTOWAIT );

			continue;
		}
#endif

		/* Event from SDK WL API */
		if (cNotifiedValue & (1<<WL_TMR_EVENT))
		{
			/* Check for the WL Blinking */
			Warning_Light_Blinking();
		}

		if (cNotifiedValue & (1<<WL_MSG_EVENT))
		{
				/* Receive Message from the WL SDK API */
				res = xQueueReceive(pv.wltxq, &wlbuf , ( TickType_t ) 20 );

				if(res != pdTRUE)
				{
					break;
				}

				func = wlbuf[WL_FUNC_INDEX];

				/* Update the result */
				wlbuf[WL_RESULT_INDEX] = SUCCESS;

				switch(func)
				{
					case WL_ACT:

						/* Update the WL blinking period */
						memcpy(&wlconf[wlbuf[WL_NUM_INDEX+1]].blk_time, &wlbuf[WL_BL_INDEX], sizeof(uint16_t));

						/* Update the WL intensity value */
						wlconf[wlbuf[WL_NUM_INDEX+1]].duty_cyle = wlbuf[WL_DC_INDEX];

						break;
					case WL_SET:

						if (WL_ON != wlbuf[WL_STATE_INDEX+1])
						{
							/* Update the WL state */
							wlconf[wlbuf[WL_NUM_INDEX+1]].wl_state &= ~WL_ON;
							wlconf[wlbuf[WL_NUM_INDEX+1]].wl_state |= WL_OFF;
						}
						else
							wlconf[wlbuf[WL_NUM_INDEX+1]].wl_state |= WL_ON;

						/* Update the Blinking time */
						memcpy(&wlconf[wlbuf[WL_NUM_INDEX+1]].blk_time,
								&wlbuf[WL_BL_INDEX+1], sizeof(uint16_t));

						wlconf[wlbuf[WL_NUM_INDEX+1]].duty_cyle = wlbuf[WL_DC_INDEX+1];

						/* Check the blinking time value is present  */
						/* If so, don't ON the WL now                 */
						/* this will be enabled from the timer       */
						if((wlconf[wlbuf[WL_NUM_INDEX+1]].blk_time == 0) &&
								(wlconf[wlbuf[WL_NUM_INDEX+1]].wl_state & WL_ON))
						{
							TakeI2CBusLock();
							/* Set the WL PWM */
							Set_Warning_Light_Intensity(pv.hi2c, wlbuf[WL_NUM_INDEX+1],
									wlconf[wlbuf[WL_NUM_INDEX+1]].duty_cyle);
							/* Set the WL ON */
							Warning_Light_On(pv.hi2c, wlbuf[WL_NUM_INDEX+1],
									wlconf[wlbuf[WL_NUM_INDEX+1]].wl_enable >> WL_REG_CURRENT_FIELD);
							GiveI2CBusLock();
						}
							/* WL Blinking period is non zero and WL is ON */
						else if((wlconf[wlbuf[WL_NUM_INDEX+1]].blk_time != 0) &&
									(wlconf[wlbuf[WL_NUM_INDEX+1]].wl_state & WL_ON) == WL_ON)
						{
							TakeI2CBusLock();
							/* Set the WL PWM */
							Set_Warning_Light_Intensity(pv.hi2c,
									wlbuf[WL_NUM_INDEX+1],
									wlconf[wlbuf[WL_NUM_INDEX+1]].duty_cyle);

							Warning_Light_On(pv.hi2c, wlbuf[WL_NUM_INDEX+1],
								wlconf[wlbuf[WL_NUM_INDEX+1]].wl_enable >> WL_REG_CURRENT_FIELD);
							GiveI2CBusLock();

				        	/* Reset the counter */
				        	wlconf[wlbuf[WL_NUM_INDEX+1]].cur_count = 0;

							/* Update the NEXT state */
							wlconf[wlbuf[WL_NUM_INDEX+1]].blnk_state = WL_OFF;

							if (pdFALSE == xTimerIsTimerActive(pv.xTimers[PS_WL_TIMER]))
							{
								/* Start WL Blinking timer */
								xTimerStart( pv.xTimers[ PS_WL_TIMER ], 0 );
							}


						}
						else
						/* OFF the Warning Light */
						if(wlconf[wlbuf[WL_NUM_INDEX+1]].wl_state & WL_OFF)
							Warning_Light_Off(pv.hi2c, wlbuf[WL_NUM_INDEX+1]);
						break;
				}
				/* Send the response to the SDK API */
				xQueueSend( pv.wlrxq, ( void * )&wlbuf, ( TickType_t ) Q_TICKSTOWAIT );
		}

		/* Clear the Notify Value */
		cNotifiedValue = 0;
	}
}

/** @brief WarningLight Timer Callback
 *
 *  This function is used for the Warning light blink
 *  functionality
 *
 *  @param  xTimer : Warning light timer handle
 *
 *  @return none
 *
 */
void WLTimerCallback( TimerHandle_t xTimer )
{
	/* Notify to the WL task to blink the WL */
	xTaskNotify( pv.wl_task, (1<<WL_TMR_EVENT), eSetBits );
}


/** @brief Start Warning light Platform service
 *
 *  This function initializes the following modules
 *     ===> Warning light DB
 *     ===> Warning light platform driver
 *     ===> Warning light software resources
 *     ===> Start the Warning light service
 *
 *  @param  None
 *
 *  @return 0 : PS_SUCCESS
 *         -1 : PS_FAILURE
 *
 */
int8_t Warning_Light_PS_Start(void)
{
	BaseType_t xReturned;

#if (SDK_SERVICE_PM == PS_ENABLE)
	/* Register the Power Mode callback */
	PM_Register_Callback(wl_deinit,NULL,wl_reinit);
#endif

	/* Create the Warning light timer for the WL blinking */
	pv.xTimers[ PS_WL_TIMER ] = xTimerCreate
	                   ( "WL_Timer",
	                	 pdMS_TO_TICKS(PS_WL_BL_TIMER),
	                     pdTRUE,
	                     ( void * ) 0,
	                     WLTimerCallback
	                   );

	if (NULL == pv.xTimers[ PS_WL_TIMER ])
	{
		LOGERROR("Unable to initialize the Warning Light timer\r\n");
		return PS_FAILURE;
	}

	/* Create WL TxQ for receiving value from the SDK API */
	pv.wltxq = xQueueCreate( WL_RX_TX_MAX_Q_SIZE, sizeof(uint32_t*));
	if(NULL == pv.wltxq)
	{
		LOGERROR("Unable to initialize the Warning Light timer\r\n");
		return PS_FAILURE;
	}

	/* Create WL RxQ for sending return value to the SDK API */
	pv.wlrxq = xQueueCreate( WL_RX_TX_MAX_Q_SIZE, sizeof(uint32_t*));
	if(NULL == pv.wlrxq)
	{
		LOGERROR("Unable to initialize the Warning Light timer\r\n");
		return PS_FAILURE;
	}

	/* Create the Warning Light task */
	xReturned = xTaskCreate(Warning_Light_ServiceStart, "WarningLight",
			WL_TASK_SIZE, NULL, PS_WL_TASK_PRIORITY,   &pv.wl_task);

    if( xReturned != pdPASS )
    {
		LOGERROR("Unable to initialize the Warning Light Task\r\n");
		return PS_FAILURE;
    }

    LOGERROR("Warning Light Platform Service task created Successfully \r\n");

	return PS_SUCCESS;
}
#endif

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
